// Copyright 2021 The Khronos Group
// SPDX-License-Identifier: Apache-2.0

// This file was generated by generate_device_frontend.py from FrameObject.h

#pragma once

#include "TreeObject.h"
#include "TreeObjects.h"

#include <vector>

namespace anari_sdk {
namespace tree {

template <>
class Object<Frame> : public DefaultObject<Frame, FrameObjectBase>
{
  std::vector<char> color;
  std::vector<float> depth;
  uint32_t size[2];
  ANARIDataType colorType;
  ANARIDataType depthType;

 public:
  Object(ANARIDevice d, ANARIObject handle);

  void commit() override;

  void *mapFrame(
      const char *, uint32_t *, uint32_t *, ANARIDataType *) override;
  void unmapFrame(const char *) override;
  void renderFrame() override;
  void discardFrame() override;
  int frameReady(ANARIWaitMask mask) override;
};

} // namespace tree
} // namespace anari_sdk
